/**
 * @license
 * Copyright Google LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/material-components/material-components-web/blob/master/LICENSE
 */
(function webpackUniversalModuleDefinition(root, factory) {
    if (typeof exports === "object" && typeof module === "object") module.exports = factory(); else if (typeof define === "function" && define.amd) define([], factory); else if (typeof exports === "object") exports["menuSurface"] = factory(); else root["mdc"] = root["mdc"] || {}, 
    root["mdc"]["menuSurface"] = factory();
})(this, function() {
    return function(modules) {
        var installedModules = {};
        function __webpack_require__(moduleId) {
            if (installedModules[moduleId]) {
                return installedModules[moduleId].exports;
            }
            var module = installedModules[moduleId] = {
                i: moduleId,
                l: false,
                exports: {}
            };
            modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
            module.l = true;
            return module.exports;
        }
        __webpack_require__.m = modules;
        __webpack_require__.c = installedModules;
        __webpack_require__.d = function(exports, name, getter) {
            if (!__webpack_require__.o(exports, name)) {
                Object.defineProperty(exports, name, {
                    configurable: false,
                    enumerable: true,
                    get: getter
                });
            }
        };
        __webpack_require__.n = function(module) {
            var getter = module && module.__esModule ? function getDefault() {
                return module["default"];
            } : function getModuleExports() {
                return module;
            };
            __webpack_require__.d(getter, "a", getter);
            return getter;
        };
        __webpack_require__.o = function(object, property) {
            return Object.prototype.hasOwnProperty.call(object, property);
        };
        __webpack_require__.p = "";
        return __webpack_require__(__webpack_require__.s = 143);
    }({
        0: function(module, exports, __webpack_require__) {
            "use strict";
            Object.defineProperty(exports, "__esModule", {
                value: true
            });
            var MDCFoundation = function() {
                function MDCFoundation(adapter) {
                    if (adapter === void 0) {
                        adapter = {};
                    }
                    this.adapter_ = adapter;
                }
                Object.defineProperty(MDCFoundation, "cssClasses", {
                    get: function get() {
                        return {};
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(MDCFoundation, "strings", {
                    get: function get() {
                        return {};
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(MDCFoundation, "numbers", {
                    get: function get() {
                        return {};
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(MDCFoundation, "defaultAdapter", {
                    get: function get() {
                        return {};
                    },
                    enumerable: true,
                    configurable: true
                });
                MDCFoundation.prototype.init = function() {};
                MDCFoundation.prototype.destroy = function() {};
                return MDCFoundation;
            }();
            exports.MDCFoundation = MDCFoundation;
            exports.default = MDCFoundation;
        },
        1: function(module, exports, __webpack_require__) {
            "use strict";
            var __read = this && this.__read || function(o, n) {
                var m = typeof Symbol === "function" && o[Symbol.iterator];
                if (!m) return o;
                var i = m.call(o), r, ar = [], e;
                try {
                    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) {
                        ar.push(r.value);
                    }
                } catch (error) {
                    e = {
                        error: error
                    };
                } finally {
                    try {
                        if (r && !r.done && (m = i["return"])) m.call(i);
                    } finally {
                        if (e) throw e.error;
                    }
                }
                return ar;
            };
            var __spread = this && this.__spread || function() {
                for (var ar = [], i = 0; i < arguments.length; i++) {
                    ar = ar.concat(__read(arguments[i]));
                }
                return ar;
            };
            Object.defineProperty(exports, "__esModule", {
                value: true
            });
            var foundation_1 = __webpack_require__(0);
            var MDCComponent = function() {
                function MDCComponent(root, foundation) {
                    var args = [];
                    for (var _i = 2; _i < arguments.length; _i++) {
                        args[_i - 2] = arguments[_i];
                    }
                    this.root_ = root;
                    this.initialize.apply(this, __spread(args));
                    this.foundation_ = foundation === undefined ? this.getDefaultFoundation() : foundation;
                    this.foundation_.init();
                    this.initialSyncWithDOM();
                }
                MDCComponent.attachTo = function(root) {
                    return new MDCComponent(root, new foundation_1.MDCFoundation({}));
                };
                MDCComponent.prototype.initialize = function() {
                    var _args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        _args[_i] = arguments[_i];
                    }
                };
                MDCComponent.prototype.getDefaultFoundation = function() {
                    throw new Error("Subclasses must override getDefaultFoundation to return a properly configured " + "foundation class");
                };
                MDCComponent.prototype.initialSyncWithDOM = function() {};
                MDCComponent.prototype.destroy = function() {
                    this.foundation_.destroy();
                };
                MDCComponent.prototype.listen = function(evtType, handler) {
                    this.root_.addEventListener(evtType, handler);
                };
                MDCComponent.prototype.unlisten = function(evtType, handler) {
                    this.root_.removeEventListener(evtType, handler);
                };
                MDCComponent.prototype.emit = function(evtType, evtData, shouldBubble) {
                    if (shouldBubble === void 0) {
                        shouldBubble = false;
                    }
                    var evt;
                    if (typeof CustomEvent === "function") {
                        evt = new CustomEvent(evtType, {
                            bubbles: shouldBubble,
                            detail: evtData
                        });
                    } else {
                        evt = document.createEvent("CustomEvent");
                        evt.initCustomEvent(evtType, shouldBubble, false, evtData);
                    }
                    this.root_.dispatchEvent(evt);
                };
                return MDCComponent;
            }();
            exports.MDCComponent = MDCComponent;
            exports.default = MDCComponent;
        },
        13: function(module, exports, __webpack_require__) {
            "use strict";
            var __extends = this && this.__extends || function() {
                var _extendStatics = function extendStatics(d, b) {
                    _extendStatics = Object.setPrototypeOf || {
                        __proto__: []
                    } instanceof Array && function(d, b) {
                        d.__proto__ = b;
                    } || function(d, b) {
                        for (var p in b) {
                            if (b.hasOwnProperty(p)) d[p] = b[p];
                        }
                    };
                    return _extendStatics(d, b);
                };
                return function(d, b) {
                    _extendStatics(d, b);
                    function __() {
                        this.constructor = d;
                    }
                    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
                };
            }();
            var __assign = this && this.__assign || function() {
                __assign = Object.assign || function(t) {
                    for (var s, i = 1, n = arguments.length; i < n; i++) {
                        s = arguments[i];
                        for (var p in s) {
                            if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
                        }
                    }
                    return t;
                };
                return __assign.apply(this, arguments);
            };
            var __values = this && this.__values || function(o) {
                var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
                if (m) return m.call(o);
                return {
                    next: function next() {
                        if (o && i >= o.length) o = void 0;
                        return {
                            value: o && o[i++],
                            done: !o
                        };
                    }
                };
            };
            Object.defineProperty(exports, "__esModule", {
                value: true
            });
            var foundation_1 = __webpack_require__(0);
            var constants_1 = __webpack_require__(9);
            var MDCMenuSurfaceFoundation = function(_super) {
                __extends(MDCMenuSurfaceFoundation, _super);
                function MDCMenuSurfaceFoundation(adapter) {
                    var _this = _super.call(this, __assign({}, MDCMenuSurfaceFoundation.defaultAdapter, adapter)) || this;
                    _this.isOpen_ = false;
                    _this.isQuickOpen_ = false;
                    _this.isHoistedElement_ = false;
                    _this.isFixedPosition_ = false;
                    _this.openAnimationEndTimerId_ = 0;
                    _this.closeAnimationEndTimerId_ = 0;
                    _this.animationRequestId_ = 0;
                    _this.anchorCorner_ = constants_1.Corner.TOP_START;
                    _this.anchorMargin_ = {
                        top: 0,
                        right: 0,
                        bottom: 0,
                        left: 0
                    };
                    _this.position_ = {
                        x: 0,
                        y: 0
                    };
                    return _this;
                }
                Object.defineProperty(MDCMenuSurfaceFoundation, "cssClasses", {
                    get: function get() {
                        return constants_1.cssClasses;
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(MDCMenuSurfaceFoundation, "strings", {
                    get: function get() {
                        return constants_1.strings;
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(MDCMenuSurfaceFoundation, "numbers", {
                    get: function get() {
                        return constants_1.numbers;
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(MDCMenuSurfaceFoundation, "Corner", {
                    get: function get() {
                        return constants_1.Corner;
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(MDCMenuSurfaceFoundation, "defaultAdapter", {
                    get: function get() {
                        return {
                            addClass: function addClass() {
                                return undefined;
                            },
                            removeClass: function removeClass() {
                                return undefined;
                            },
                            hasClass: function hasClass() {
                                return false;
                            },
                            hasAnchor: function hasAnchor() {
                                return false;
                            },
                            isElementInContainer: function isElementInContainer() {
                                return false;
                            },
                            isFocused: function isFocused() {
                                return false;
                            },
                            isFirstElementFocused: function isFirstElementFocused() {
                                return false;
                            },
                            isLastElementFocused: function isLastElementFocused() {
                                return false;
                            },
                            isRtl: function isRtl() {
                                return false;
                            },
                            getInnerDimensions: function getInnerDimensions() {
                                return {
                                    height: 0,
                                    width: 0
                                };
                            },
                            getAnchorDimensions: function getAnchorDimensions() {
                                return null;
                            },
                            getWindowDimensions: function getWindowDimensions() {
                                return {
                                    height: 0,
                                    width: 0
                                };
                            },
                            getBodyDimensions: function getBodyDimensions() {
                                return {
                                    height: 0,
                                    width: 0
                                };
                            },
                            getWindowScroll: function getWindowScroll() {
                                return {
                                    x: 0,
                                    y: 0
                                };
                            },
                            setPosition: function setPosition() {
                                return undefined;
                            },
                            setMaxHeight: function setMaxHeight() {
                                return undefined;
                            },
                            setTransformOrigin: function setTransformOrigin() {
                                return undefined;
                            },
                            saveFocus: function saveFocus() {
                                return undefined;
                            },
                            restoreFocus: function restoreFocus() {
                                return undefined;
                            },
                            focusFirstElement: function focusFirstElement() {
                                return undefined;
                            },
                            focusLastElement: function focusLastElement() {
                                return undefined;
                            },
                            notifyClose: function notifyClose() {
                                return undefined;
                            },
                            notifyOpen: function notifyOpen() {
                                return undefined;
                            }
                        };
                    },
                    enumerable: true,
                    configurable: true
                });
                MDCMenuSurfaceFoundation.prototype.init = function() {
                    var _a = MDCMenuSurfaceFoundation.cssClasses, ROOT = _a.ROOT, OPEN = _a.OPEN;
                    if (!this.adapter_.hasClass(ROOT)) {
                        throw new Error(ROOT + " class required in root element.");
                    }
                    if (this.adapter_.hasClass(OPEN)) {
                        this.isOpen_ = true;
                    }
                };
                MDCMenuSurfaceFoundation.prototype.destroy = function() {
                    clearTimeout(this.openAnimationEndTimerId_);
                    clearTimeout(this.closeAnimationEndTimerId_);
                    cancelAnimationFrame(this.animationRequestId_);
                };
                MDCMenuSurfaceFoundation.prototype.setAnchorCorner = function(corner) {
                    this.anchorCorner_ = corner;
                };
                MDCMenuSurfaceFoundation.prototype.setAnchorMargin = function(margin) {
                    this.anchorMargin_.top = margin.top || 0;
                    this.anchorMargin_.right = margin.right || 0;
                    this.anchorMargin_.bottom = margin.bottom || 0;
                    this.anchorMargin_.left = margin.left || 0;
                };
                MDCMenuSurfaceFoundation.prototype.setIsHoisted = function(isHoisted) {
                    this.isHoistedElement_ = isHoisted;
                };
                MDCMenuSurfaceFoundation.prototype.setFixedPosition = function(isFixedPosition) {
                    this.isFixedPosition_ = isFixedPosition;
                };
                MDCMenuSurfaceFoundation.prototype.setAbsolutePosition = function(x, y) {
                    this.position_.x = this.isFinite_(x) ? x : 0;
                    this.position_.y = this.isFinite_(y) ? y : 0;
                };
                MDCMenuSurfaceFoundation.prototype.setQuickOpen = function(quickOpen) {
                    this.isQuickOpen_ = quickOpen;
                };
                MDCMenuSurfaceFoundation.prototype.isOpen = function() {
                    return this.isOpen_;
                };
                MDCMenuSurfaceFoundation.prototype.open = function() {
                    var _this = this;
                    this.adapter_.saveFocus();
                    if (!this.isQuickOpen_) {
                        this.adapter_.addClass(MDCMenuSurfaceFoundation.cssClasses.ANIMATING_OPEN);
                    }
                    this.animationRequestId_ = requestAnimationFrame(function() {
                        _this.adapter_.addClass(MDCMenuSurfaceFoundation.cssClasses.OPEN);
                        _this.dimensions_ = _this.adapter_.getInnerDimensions();
                        _this.autoPosition_();
                        if (_this.isQuickOpen_) {
                            _this.adapter_.notifyOpen();
                        } else {
                            _this.openAnimationEndTimerId_ = setTimeout(function() {
                                _this.openAnimationEndTimerId_ = 0;
                                _this.adapter_.removeClass(MDCMenuSurfaceFoundation.cssClasses.ANIMATING_OPEN);
                                _this.adapter_.notifyOpen();
                            }, constants_1.numbers.TRANSITION_OPEN_DURATION);
                        }
                    });
                    this.isOpen_ = true;
                };
                MDCMenuSurfaceFoundation.prototype.close = function() {
                    var _this = this;
                    if (!this.isQuickOpen_) {
                        this.adapter_.addClass(MDCMenuSurfaceFoundation.cssClasses.ANIMATING_CLOSED);
                    }
                    requestAnimationFrame(function() {
                        _this.adapter_.removeClass(MDCMenuSurfaceFoundation.cssClasses.OPEN);
                        if (_this.isQuickOpen_) {
                            _this.adapter_.notifyClose();
                        } else {
                            _this.closeAnimationEndTimerId_ = setTimeout(function() {
                                _this.closeAnimationEndTimerId_ = 0;
                                _this.adapter_.removeClass(MDCMenuSurfaceFoundation.cssClasses.ANIMATING_CLOSED);
                                _this.adapter_.notifyClose();
                            }, constants_1.numbers.TRANSITION_CLOSE_DURATION);
                        }
                    });
                    this.isOpen_ = false;
                    this.maybeRestoreFocus_();
                };
                MDCMenuSurfaceFoundation.prototype.handleBodyClick = function(evt) {
                    var el = evt.target;
                    if (this.adapter_.isElementInContainer(el)) {
                        return;
                    }
                    this.close();
                };
                MDCMenuSurfaceFoundation.prototype.handleKeydown = function(evt) {
                    var keyCode = evt.keyCode, key = evt.key, shiftKey = evt.shiftKey;
                    var isEscape = key === "Escape" || keyCode === 27;
                    var isTab = key === "Tab" || keyCode === 9;
                    if (isEscape) {
                        this.close();
                    } else if (isTab) {
                        if (this.adapter_.isLastElementFocused() && !shiftKey) {
                            this.adapter_.focusFirstElement();
                            evt.preventDefault();
                        } else if (this.adapter_.isFirstElementFocused() && shiftKey) {
                            this.adapter_.focusLastElement();
                            evt.preventDefault();
                        }
                    }
                };
                MDCMenuSurfaceFoundation.prototype.autoPosition_ = function() {
                    var _a;
                    this.measurements_ = this.getAutoLayoutMeasurements_();
                    var corner = this.getOriginCorner_();
                    var maxMenuSurfaceHeight = this.getMenuSurfaceMaxHeight_(corner);
                    var verticalAlignment = this.hasBit_(corner, constants_1.CornerBit.BOTTOM) ? "bottom" : "top";
                    var horizontalAlignment = this.hasBit_(corner, constants_1.CornerBit.RIGHT) ? "right" : "left";
                    var horizontalOffset = this.getHorizontalOriginOffset_(corner);
                    var verticalOffset = this.getVerticalOriginOffset_(corner);
                    var _b = this.measurements_, anchorSize = _b.anchorSize, surfaceSize = _b.surfaceSize;
                    var position = (_a = {}, _a[horizontalAlignment] = horizontalOffset, _a[verticalAlignment] = verticalOffset, 
                    _a);
                    if (anchorSize.width / surfaceSize.width > constants_1.numbers.ANCHOR_TO_MENU_SURFACE_WIDTH_RATIO) {
                        horizontalAlignment = "center";
                    }
                    if (this.isHoistedElement_ || this.isFixedPosition_) {
                        this.adjustPositionForHoistedElement_(position);
                    }
                    this.adapter_.setTransformOrigin(horizontalAlignment + " " + verticalAlignment);
                    this.adapter_.setPosition(position);
                    this.adapter_.setMaxHeight(maxMenuSurfaceHeight ? maxMenuSurfaceHeight + "px" : "");
                };
                MDCMenuSurfaceFoundation.prototype.getAutoLayoutMeasurements_ = function() {
                    var anchorRect = this.adapter_.getAnchorDimensions();
                    var bodySize = this.adapter_.getBodyDimensions();
                    var viewportSize = this.adapter_.getWindowDimensions();
                    var windowScroll = this.adapter_.getWindowScroll();
                    if (!anchorRect) {
                        anchorRect = {
                            top: this.position_.y,
                            right: this.position_.x,
                            bottom: this.position_.y,
                            left: this.position_.x,
                            width: 0,
                            height: 0
                        };
                    }
                    return {
                        anchorSize: anchorRect,
                        bodySize: bodySize,
                        surfaceSize: this.dimensions_,
                        viewportDistance: {
                            top: anchorRect.top,
                            right: viewportSize.width - anchorRect.right,
                            bottom: viewportSize.height - anchorRect.bottom,
                            left: anchorRect.left
                        },
                        viewportSize: viewportSize,
                        windowScroll: windowScroll
                    };
                };
                MDCMenuSurfaceFoundation.prototype.getOriginCorner_ = function() {
                    var corner = constants_1.Corner.TOP_LEFT;
                    var _a = this.measurements_, viewportDistance = _a.viewportDistance, anchorSize = _a.anchorSize, surfaceSize = _a.surfaceSize;
                    var isBottomAligned = this.hasBit_(this.anchorCorner_, constants_1.CornerBit.BOTTOM);
                    var availableTop = isBottomAligned ? viewportDistance.top + anchorSize.height + this.anchorMargin_.bottom : viewportDistance.top + this.anchorMargin_.top;
                    var availableBottom = isBottomAligned ? viewportDistance.bottom - this.anchorMargin_.bottom : viewportDistance.bottom + anchorSize.height - this.anchorMargin_.top;
                    var topOverflow = surfaceSize.height - availableTop;
                    var bottomOverflow = surfaceSize.height - availableBottom;
                    if (bottomOverflow > 0 && topOverflow < bottomOverflow) {
                        corner = this.setBit_(corner, constants_1.CornerBit.BOTTOM);
                    }
                    var isRtl = this.adapter_.isRtl();
                    var isFlipRtl = this.hasBit_(this.anchorCorner_, constants_1.CornerBit.FLIP_RTL);
                    var avoidHorizontalOverlap = this.hasBit_(this.anchorCorner_, constants_1.CornerBit.RIGHT);
                    var isAlignedRight = avoidHorizontalOverlap && !isRtl || !avoidHorizontalOverlap && isFlipRtl && isRtl;
                    var availableLeft = isAlignedRight ? viewportDistance.left + anchorSize.width + this.anchorMargin_.right : viewportDistance.left + this.anchorMargin_.left;
                    var availableRight = isAlignedRight ? viewportDistance.right - this.anchorMargin_.right : viewportDistance.right + anchorSize.width - this.anchorMargin_.left;
                    var leftOverflow = surfaceSize.width - availableLeft;
                    var rightOverflow = surfaceSize.width - availableRight;
                    if (leftOverflow < 0 && isAlignedRight && isRtl || avoidHorizontalOverlap && !isAlignedRight && leftOverflow < 0 || rightOverflow > 0 && leftOverflow < rightOverflow) {
                        corner = this.setBit_(corner, constants_1.CornerBit.RIGHT);
                    }
                    return corner;
                };
                MDCMenuSurfaceFoundation.prototype.getMenuSurfaceMaxHeight_ = function(corner) {
                    var viewportDistance = this.measurements_.viewportDistance;
                    var maxHeight = 0;
                    var isBottomAligned = this.hasBit_(corner, constants_1.CornerBit.BOTTOM);
                    var isBottomAnchored = this.hasBit_(this.anchorCorner_, constants_1.CornerBit.BOTTOM);
                    var MARGIN_TO_EDGE = MDCMenuSurfaceFoundation.numbers.MARGIN_TO_EDGE;
                    if (isBottomAligned) {
                        maxHeight = viewportDistance.top + this.anchorMargin_.top - MARGIN_TO_EDGE;
                        if (!isBottomAnchored) {
                            maxHeight += this.measurements_.anchorSize.height;
                        }
                    } else {
                        maxHeight = viewportDistance.bottom - this.anchorMargin_.bottom + this.measurements_.anchorSize.height - MARGIN_TO_EDGE;
                        if (isBottomAnchored) {
                            maxHeight -= this.measurements_.anchorSize.height;
                        }
                    }
                    return maxHeight;
                };
                MDCMenuSurfaceFoundation.prototype.getHorizontalOriginOffset_ = function(corner) {
                    var anchorSize = this.measurements_.anchorSize;
                    var isRightAligned = this.hasBit_(corner, constants_1.CornerBit.RIGHT);
                    var avoidHorizontalOverlap = this.hasBit_(this.anchorCorner_, constants_1.CornerBit.RIGHT);
                    if (isRightAligned) {
                        var rightOffset = avoidHorizontalOverlap ? anchorSize.width - this.anchorMargin_.left : this.anchorMargin_.right;
                        if (this.isHoistedElement_ || this.isFixedPosition_) {
                            return rightOffset - (this.measurements_.viewportSize.width - this.measurements_.bodySize.width);
                        }
                        return rightOffset;
                    }
                    return avoidHorizontalOverlap ? anchorSize.width - this.anchorMargin_.right : this.anchorMargin_.left;
                };
                MDCMenuSurfaceFoundation.prototype.getVerticalOriginOffset_ = function(corner) {
                    var anchorSize = this.measurements_.anchorSize;
                    var isBottomAligned = this.hasBit_(corner, constants_1.CornerBit.BOTTOM);
                    var avoidVerticalOverlap = this.hasBit_(this.anchorCorner_, constants_1.CornerBit.BOTTOM);
                    var y = 0;
                    if (isBottomAligned) {
                        y = avoidVerticalOverlap ? anchorSize.height - this.anchorMargin_.top : -this.anchorMargin_.bottom;
                    } else {
                        y = avoidVerticalOverlap ? anchorSize.height + this.anchorMargin_.bottom : this.anchorMargin_.top;
                    }
                    return y;
                };
                MDCMenuSurfaceFoundation.prototype.adjustPositionForHoistedElement_ = function(position) {
                    var e_1, _a;
                    var _b = this.measurements_, windowScroll = _b.windowScroll, viewportDistance = _b.viewportDistance;
                    var props = Object.keys(position);
                    try {
                        for (var props_1 = __values(props), props_1_1 = props_1.next(); !props_1_1.done; props_1_1 = props_1.next()) {
                            var prop = props_1_1.value;
                            var value = position[prop] || 0;
                            value += viewportDistance[prop];
                            if (!this.isFixedPosition_) {
                                if (prop === "top") {
                                    value += windowScroll.y;
                                } else if (prop === "bottom") {
                                    value -= windowScroll.y;
                                } else if (prop === "left") {
                                    value += windowScroll.x;
                                } else {
                                    value -= windowScroll.x;
                                }
                            }
                            position[prop] = value;
                        }
                    } catch (e_1_1) {
                        e_1 = {
                            error: e_1_1
                        };
                    } finally {
                        try {
                            if (props_1_1 && !props_1_1.done && (_a = props_1.return)) _a.call(props_1);
                        } finally {
                            if (e_1) throw e_1.error;
                        }
                    }
                };
                MDCMenuSurfaceFoundation.prototype.maybeRestoreFocus_ = function() {
                    var isRootFocused = this.adapter_.isFocused();
                    var childHasFocus = document.activeElement && this.adapter_.isElementInContainer(document.activeElement);
                    if (isRootFocused || childHasFocus) {
                        this.adapter_.restoreFocus();
                    }
                };
                MDCMenuSurfaceFoundation.prototype.hasBit_ = function(corner, bit) {
                    return Boolean(corner & bit);
                };
                MDCMenuSurfaceFoundation.prototype.setBit_ = function(corner, bit) {
                    return corner | bit;
                };
                MDCMenuSurfaceFoundation.prototype.isFinite_ = function(num) {
                    return typeof num === "number" && isFinite(num);
                };
                return MDCMenuSurfaceFoundation;
            }(foundation_1.MDCFoundation);
            exports.MDCMenuSurfaceFoundation = MDCMenuSurfaceFoundation;
            exports.default = MDCMenuSurfaceFoundation;
        },
        143: function(module, exports, __webpack_require__) {
            "use strict";
            function __export(m) {
                for (var p in m) {
                    if (!exports.hasOwnProperty(p)) exports[p] = m[p];
                }
            }
            var __importStar = this && this.__importStar || function(mod) {
                if (mod && mod.__esModule) return mod;
                var result = {};
                if (mod != null) for (var k in mod) {
                    if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
                }
                result["default"] = mod;
                return result;
            };
            Object.defineProperty(exports, "__esModule", {
                value: true
            });
            var util = __importStar(__webpack_require__(21));
            exports.util = util;
            var constants_1 = __webpack_require__(9);
            exports.Corner = constants_1.Corner;
            exports.CornerBit = constants_1.CornerBit;
            __export(__webpack_require__(30));
            __export(__webpack_require__(9));
            __export(__webpack_require__(13));
        },
        21: function(module, exports, __webpack_require__) {
            "use strict";
            Object.defineProperty(exports, "__esModule", {
                value: true
            });
            var cachedCssTransformPropertyName_;
            function getTransformPropertyName(globalObj, forceRefresh) {
                if (forceRefresh === void 0) {
                    forceRefresh = false;
                }
                if (cachedCssTransformPropertyName_ === undefined || forceRefresh) {
                    var el = globalObj.document.createElement("div");
                    cachedCssTransformPropertyName_ = "transform" in el.style ? "transform" : "webkitTransform";
                }
                return cachedCssTransformPropertyName_;
            }
            exports.getTransformPropertyName = getTransformPropertyName;
        },
        30: function(module, exports, __webpack_require__) {
            "use strict";
            var __extends = this && this.__extends || function() {
                var _extendStatics = function extendStatics(d, b) {
                    _extendStatics = Object.setPrototypeOf || {
                        __proto__: []
                    } instanceof Array && function(d, b) {
                        d.__proto__ = b;
                    } || function(d, b) {
                        for (var p in b) {
                            if (b.hasOwnProperty(p)) d[p] = b[p];
                        }
                    };
                    return _extendStatics(d, b);
                };
                return function(d, b) {
                    _extendStatics(d, b);
                    function __() {
                        this.constructor = d;
                    }
                    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
                };
            }();
            var __importStar = this && this.__importStar || function(mod) {
                if (mod && mod.__esModule) return mod;
                var result = {};
                if (mod != null) for (var k in mod) {
                    if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
                }
                result["default"] = mod;
                return result;
            };
            Object.defineProperty(exports, "__esModule", {
                value: true
            });
            var component_1 = __webpack_require__(1);
            var constants_1 = __webpack_require__(9);
            var foundation_1 = __webpack_require__(13);
            var util = __importStar(__webpack_require__(21));
            var MDCMenuSurface = function(_super) {
                __extends(MDCMenuSurface, _super);
                function MDCMenuSurface() {
                    return _super !== null && _super.apply(this, arguments) || this;
                }
                MDCMenuSurface.attachTo = function(root) {
                    return new MDCMenuSurface(root);
                };
                MDCMenuSurface.prototype.initialSyncWithDOM = function() {
                    var _this = this;
                    var parentEl = this.root_.parentElement;
                    this.anchorElement = parentEl && parentEl.classList.contains(constants_1.cssClasses.ANCHOR) ? parentEl : null;
                    if (this.root_.classList.contains(constants_1.cssClasses.FIXED)) {
                        this.setFixedPosition(true);
                    }
                    this.handleKeydown_ = function(evt) {
                        return _this.foundation_.handleKeydown(evt);
                    };
                    this.handleBodyClick_ = function(evt) {
                        return _this.foundation_.handleBodyClick(evt);
                    };
                    this.registerBodyClickListener_ = function() {
                        return document.body.addEventListener("click", _this.handleBodyClick_);
                    };
                    this.deregisterBodyClickListener_ = function() {
                        return document.body.removeEventListener("click", _this.handleBodyClick_);
                    };
                    this.listen("keydown", this.handleKeydown_);
                    this.listen(constants_1.strings.OPENED_EVENT, this.registerBodyClickListener_);
                    this.listen(constants_1.strings.CLOSED_EVENT, this.deregisterBodyClickListener_);
                };
                MDCMenuSurface.prototype.destroy = function() {
                    this.unlisten("keydown", this.handleKeydown_);
                    this.unlisten(constants_1.strings.OPENED_EVENT, this.registerBodyClickListener_);
                    this.unlisten(constants_1.strings.CLOSED_EVENT, this.deregisterBodyClickListener_);
                    _super.prototype.destroy.call(this);
                };
                Object.defineProperty(MDCMenuSurface.prototype, "open", {
                    get: function get() {
                        return this.foundation_.isOpen();
                    },
                    set: function set(value) {
                        if (value) {
                            var focusableElements = this.root_.querySelectorAll(constants_1.strings.FOCUSABLE_ELEMENTS);
                            this.firstFocusableElement_ = focusableElements[0];
                            this.lastFocusableElement_ = focusableElements[focusableElements.length - 1];
                            this.foundation_.open();
                        } else {
                            this.foundation_.close();
                        }
                    },
                    enumerable: true,
                    configurable: true
                });
                Object.defineProperty(MDCMenuSurface.prototype, "quickOpen", {
                    set: function set(quickOpen) {
                        this.foundation_.setQuickOpen(quickOpen);
                    },
                    enumerable: true,
                    configurable: true
                });
                MDCMenuSurface.prototype.hoistMenuToBody = function() {
                    document.body.appendChild(this.root_);
                    this.setIsHoisted(true);
                };
                MDCMenuSurface.prototype.setIsHoisted = function(isHoisted) {
                    this.foundation_.setIsHoisted(isHoisted);
                };
                MDCMenuSurface.prototype.setMenuSurfaceAnchorElement = function(element) {
                    this.anchorElement = element;
                };
                MDCMenuSurface.prototype.setFixedPosition = function(isFixed) {
                    if (isFixed) {
                        this.root_.classList.add(constants_1.cssClasses.FIXED);
                    } else {
                        this.root_.classList.remove(constants_1.cssClasses.FIXED);
                    }
                    this.foundation_.setFixedPosition(isFixed);
                };
                MDCMenuSurface.prototype.setAbsolutePosition = function(x, y) {
                    this.foundation_.setAbsolutePosition(x, y);
                    this.setIsHoisted(true);
                };
                MDCMenuSurface.prototype.setAnchorCorner = function(corner) {
                    this.foundation_.setAnchorCorner(corner);
                };
                MDCMenuSurface.prototype.setAnchorMargin = function(margin) {
                    this.foundation_.setAnchorMargin(margin);
                };
                MDCMenuSurface.prototype.getDefaultFoundation = function() {
                    var _this = this;
                    var adapter = {
                        addClass: function addClass(className) {
                            return _this.root_.classList.add(className);
                        },
                        removeClass: function removeClass(className) {
                            return _this.root_.classList.remove(className);
                        },
                        hasClass: function hasClass(className) {
                            return _this.root_.classList.contains(className);
                        },
                        hasAnchor: function hasAnchor() {
                            return !!_this.anchorElement;
                        },
                        notifyClose: function notifyClose() {
                            return _this.emit(foundation_1.MDCMenuSurfaceFoundation.strings.CLOSED_EVENT, {});
                        },
                        notifyOpen: function notifyOpen() {
                            return _this.emit(foundation_1.MDCMenuSurfaceFoundation.strings.OPENED_EVENT, {});
                        },
                        isElementInContainer: function isElementInContainer(el) {
                            return _this.root_.contains(el);
                        },
                        isRtl: function isRtl() {
                            return getComputedStyle(_this.root_).getPropertyValue("direction") === "rtl";
                        },
                        setTransformOrigin: function setTransformOrigin(origin) {
                            var propertyName = util.getTransformPropertyName(window) + "-origin";
                            _this.root_.style.setProperty(propertyName, origin);
                        },
                        isFocused: function isFocused() {
                            return document.activeElement === _this.root_;
                        },
                        saveFocus: function saveFocus() {
                            _this.previousFocus_ = document.activeElement;
                        },
                        restoreFocus: function restoreFocus() {
                            if (_this.root_.contains(document.activeElement)) {
                                if (_this.previousFocus_ && _this.previousFocus_.focus) {
                                    _this.previousFocus_.focus();
                                }
                            }
                        },
                        isFirstElementFocused: function isFirstElementFocused() {
                            return _this.firstFocusableElement_ ? _this.firstFocusableElement_ === document.activeElement : false;
                        },
                        isLastElementFocused: function isLastElementFocused() {
                            return _this.lastFocusableElement_ ? _this.lastFocusableElement_ === document.activeElement : false;
                        },
                        focusFirstElement: function focusFirstElement() {
                            return _this.firstFocusableElement_ && _this.firstFocusableElement_.focus && _this.firstFocusableElement_.focus();
                        },
                        focusLastElement: function focusLastElement() {
                            return _this.lastFocusableElement_ && _this.lastFocusableElement_.focus && _this.lastFocusableElement_.focus();
                        },
                        getInnerDimensions: function getInnerDimensions() {
                            return {
                                width: _this.root_.offsetWidth,
                                height: _this.root_.offsetHeight
                            };
                        },
                        getAnchorDimensions: function getAnchorDimensions() {
                            return _this.anchorElement ? _this.anchorElement.getBoundingClientRect() : null;
                        },
                        getWindowDimensions: function getWindowDimensions() {
                            return {
                                width: window.innerWidth,
                                height: window.innerHeight
                            };
                        },
                        getBodyDimensions: function getBodyDimensions() {
                            return {
                                width: document.body.clientWidth,
                                height: document.body.clientHeight
                            };
                        },
                        getWindowScroll: function getWindowScroll() {
                            return {
                                x: window.pageXOffset,
                                y: window.pageYOffset
                            };
                        },
                        setPosition: function setPosition(position) {
                            _this.root_.style.left = "left" in position ? position.left + "px" : "";
                            _this.root_.style.right = "right" in position ? position.right + "px" : "";
                            _this.root_.style.top = "top" in position ? position.top + "px" : "";
                            _this.root_.style.bottom = "bottom" in position ? position.bottom + "px" : "";
                        },
                        setMaxHeight: function setMaxHeight(height) {
                            _this.root_.style.maxHeight = height;
                        }
                    };
                    return new foundation_1.MDCMenuSurfaceFoundation(adapter);
                };
                return MDCMenuSurface;
            }(component_1.MDCComponent);
            exports.MDCMenuSurface = MDCMenuSurface;
        },
        9: function(module, exports, __webpack_require__) {
            "use strict";
            Object.defineProperty(exports, "__esModule", {
                value: true
            });
            var cssClasses = {
                ANCHOR: "mdc-menu-surface--anchor",
                ANIMATING_CLOSED: "mdc-menu-surface--animating-closed",
                ANIMATING_OPEN: "mdc-menu-surface--animating-open",
                FIXED: "mdc-menu-surface--fixed",
                OPEN: "mdc-menu-surface--open",
                ROOT: "mdc-menu-surface"
            };
            exports.cssClasses = cssClasses;
            var strings = {
                CLOSED_EVENT: "MDCMenuSurface:closed",
                OPENED_EVENT: "MDCMenuSurface:opened",
                FOCUSABLE_ELEMENTS: [ "button:not(:disabled)", '[href]:not([aria-disabled="true"])', "input:not(:disabled)", "select:not(:disabled)", "textarea:not(:disabled)", '[tabindex]:not([tabindex="-1"]):not([aria-disabled="true"])' ].join(", ")
            };
            exports.strings = strings;
            var numbers = {
                TRANSITION_OPEN_DURATION: 120,
                TRANSITION_CLOSE_DURATION: 75,
                MARGIN_TO_EDGE: 32,
                ANCHOR_TO_MENU_SURFACE_WIDTH_RATIO: .67
            };
            exports.numbers = numbers;
            var CornerBit;
            (function(CornerBit) {
                CornerBit[CornerBit["BOTTOM"] = 1] = "BOTTOM";
                CornerBit[CornerBit["CENTER"] = 2] = "CENTER";
                CornerBit[CornerBit["RIGHT"] = 4] = "RIGHT";
                CornerBit[CornerBit["FLIP_RTL"] = 8] = "FLIP_RTL";
            })(CornerBit || (CornerBit = {}));
            exports.CornerBit = CornerBit;
            var Corner;
            (function(Corner) {
                Corner[Corner["TOP_LEFT"] = 0] = "TOP_LEFT";
                Corner[Corner["TOP_RIGHT"] = 4] = "TOP_RIGHT";
                Corner[Corner["BOTTOM_LEFT"] = 1] = "BOTTOM_LEFT";
                Corner[Corner["BOTTOM_RIGHT"] = 5] = "BOTTOM_RIGHT";
                Corner[Corner["TOP_START"] = 8] = "TOP_START";
                Corner[Corner["TOP_END"] = 12] = "TOP_END";
                Corner[Corner["BOTTOM_START"] = 9] = "BOTTOM_START";
                Corner[Corner["BOTTOM_END"] = 13] = "BOTTOM_END";
            })(Corner || (Corner = {}));
            exports.Corner = Corner;
        }
    });
});
//# sourceMappingURL=mdc.menuSurface.js.map